unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, OpenGL, DGLUT, ComCtrls, Math, Menus;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    StatusBar1: TStatusBar;
    Panel3: TPanel;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
  private
    procedure WMPaint(var Msg: TWMPaint); message WM_PAINT;
    procedure WMTimer(var Msg: TWMTimer); message WM_TIMER;
    procedure PrepareImage(bmap: string);
    procedure Init;
  public
    { Public declarations }
  end;
  TKamen = array [0..14, 0..2] of GLFloat;

const
  fogColor : Array [0..3] of GLFloat = (0.8, 0.8, 0.8, 1.0);

  lmodel_ambient  : array[0..3] of GLfloat = ( 0.1, 0.1, 0.1, 1.0 );

  Ambient1: Array [0..3] of GLfloat = (0.1, 0.1, 0.1, 1.0);
  Ambient2: Array [0..3] of GLfloat = (0.2, 0.2, 0.2, 1.0);
  Ambient3: Array [0..3] of GLfloat = (0.8, 0.8, 0.8, 1.0);
  Specular1: Array [0..3] of GLfloat = (0.1, 0.1, 0.1, 1.0);
  Diffuse1: Array [0..3] of GLfloat = (0.99, 0.99, 0.99, 1.0);
  Diffuse2: Array [0..3] of GLfloat = (1.0, 1.0, 1.0, 1.0);
  sColor: Array [0..3] of GLfloat = (1.0, 1.0, 1.0, 0.0);
    mat_ambient         : array[0..3] of GLfloat = ( 0.0, 0.0, 0.0, 1.0 );
    mat_ambient2        : array[0..3] of GLfloat = ( 0.50, 0.50, 0.50, 1.0 );
    mat_ambient3        : array[0..3] of GLfloat = ( 0.90, 0.90, 0.90, 1.0 );
    mat_diffuse2        : array[0..3] of GLfloat = ( 0.5, 0.5, 0.5, 1.0 );
    mat_diffuse         : array[0..3] of GLfloat = ( 0.99, 0.99, 0.99, 1.0 );
    mat_specular        : array[0..3] of GLfloat = ( 1.0, 1.0, 1.0, 1.0 );
    high_shininess      : array[0..0] of GLfloat = ( 0.0 );

    no_mat              : array[0..3] of GLfloat = ( 0.0, 0.0, 0.0, 1.0 );
    low_shininess       : array[0..0] of GLfloat = ( 100.0 );

  POINT_COUNT = 3000;  // 

  Zabor = 1;
  Stena = 2;
  Nebo = 3;
  Ploshad = 4;
  Kamen1 = 5;
  Kamen2 = 6;
  Kamen3 = 7;
  Kamen4 = 8;
  Luga1 = 9;
{  Kamen5 = 9;  10 .. 110 -    
  Kamen6 = 10;
  Kamen7 = 11;
  Kamen8 = 12;
  Kamen9 = 13;
  Kamen10 = 14;
  Kamen11 = 15;
  Kamen12 = 16;
  Kamen13 = 17;
  Kamen14 = 18;}

var
  Form1: TForm1;
  DC: HDC;
  HRC: HGLRC;
  DCPanel3: HDC;
  Perspective: GlFloat = 45.0;
  Sphere: GLUquadricObj;
  XPos: GlFloat = 0.0; YPos: GlFloat = 0.0; ZPos: GlFloat = -50.0;
  TimerID: DWORD;
  Xa, Ya, Za: GLfloat;
  AngleY: Integer = 0;
  AngleX: Integer = 0;
  AngleYAld: Integer;
  Angle: GLfloat = 0; //   
  eyex, eyey, eyez,
  centerx, centery, centerz,
  upx, upy, upz : GLdouble;
  Position1: Array [0..3] of GLFloat;
  Position2: Array [0..3] of GLFloat;
  RadiusMax: GlFloat = 50;
  XDown, YDown: Integer; //   

  newCount, frameCount, lastCount: LongInt;
  fpsRate : GLfloat;

  points: Array [0..POINT_COUNT - 1] of TGLArrayf3; //  
  motion: Array [0..POINT_COUNT - 1] of TGLArrayf3;

  ClearBitMap: TBitMap;

  RadiusFontan: GLFloat = 1.0;
  Kam1: TKamen;
  Kam2: TKamen;
  Kam3: TKamen;
  Kam4: TKamen;
  KamFontan: array [1..100] of TKamen;
{  Kam5: TKamen;  //
  Kam6: TKamen;  //
  Kam7: TKamen;  //
  Kam8: TKamen;  //
  Kam9: TKamen;  //
  Kam10: TKamen; //   
  Kam11: TKamen; //
  Kam12: TKamen; //
  Kam13: TKamen; //
  Kam14: TKamen; //}

implementation

{$R *.dfm}

procedure CreateArray(var A: TKamen; Scale: GLFloat);
begin
 A[14, 0] := -1;
 A[14, 1] := 1;
 A[0, 0] := -Random * Scale;
 A[0, 1] := -Random * Scale;
 A[0, 2] := -Random * Scale;
 A[1, 0] := Random * Scale;
 A[1, 1] := -Random * Scale;
 A[1, 2] := -Random * Scale;
 A[2, 0] := Random * Scale;
 A[2, 1] := Random * Scale;
 A[2, 2] := -Random * Scale;
 A[3, 0] := -Random * Scale;
 A[3, 1] := Random * Scale;
 A[3, 2] := -Random * Scale;
 A[4, 0] := -Random * Scale;
 A[4, 1] := Random * Scale;
 A[4, 2] := Random * Scale;
 A[5, 0] := -Random * Scale;
 A[5, 1] := -Random * Scale;
 A[5, 2] := Random * Scale;
 A[6, 0] := Random * Scale;
 A[6, 1] := -Random * Scale;
 A[6, 2] := Random * Scale;
 A[7, 0] := Random * Scale;
 A[7, 1] := Random * Scale;
 A[7, 2] := Random * Scale;
 A[8, 0] := Random / 2 * A[14, Random(2)] * Scale;
 A[8, 1] := Random / 2 * A[14, Random(2)] * Scale;
 A[8, 2] := -Random * Scale;
 A[9, 0] := -Random * Scale;
 A[9, 1] := Random / 2 * A[14, Random(2)] * Scale;
 A[9, 2] := Random / 2 * A[14, Random(2)] * Scale;
 A[10, 0] := Random / 2 * A[14, Random(2)] * Scale;
 A[10, 1] := Random / 2 * A[14, Random(2)] * Scale;
 A[10, 2] := Random * Scale;
 A[11, 0] := Random * Scale;
 A[11, 1] := Random / 2 * A[14, Random(2)] * Scale;
 A[11, 2] := Random / 2 * A[14, Random(2)] * Scale;
 A[12, 0] := Random / 2 * A[14, Random(2)] * Scale;
 A[12, 1] := Random * Scale;
 A[12, 2] := Random / 2 * A[14, Random(2)] * Scale;
 A[13, 0] := Random / 2 * A[14, Random(2)] * Scale;
 A[13, 1] := -Random * Scale;
 A[13, 2] := Random / 2 * A[14, Random(2)] * Scale;
end;

procedure DrawKamen(A: TKamen);
begin
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[0, 0], A[0, 1], A[0, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[1, 0], A[1, 1], A[1, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[8, 0], A[8, 1], A[8, 2]);
   glTexCoord2d(-1,1);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[1, 0], A[1, 1], A[1, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[2, 0], A[2, 1], A[2, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[8, 0], A[8, 1], A[8, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[2, 0], A[2, 1], A[2, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[3, 0], A[3, 1], A[3, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[8, 0], A[8, 1], A[8, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[0, 0], A[0, 1], A[0, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[3, 0], A[3, 1], A[3, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[8, 0], A[8, 1], A[8, 2]);
 glEnd;

 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[0, 0], A[0, 1], A[0, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[3, 0], A[3, 1], A[3, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[9, 0], A[9, 1], A[9, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[3, 0], A[3, 1], A[3, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[4, 0], A[4, 1], A[4, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[9, 0], A[9, 1], A[9, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[4, 0], A[4, 1], A[4, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[5, 0], A[5, 1], A[5, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[9, 0], A[9, 1], A[9, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[0, 0], A[0, 1], A[0, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[5, 0], A[5, 1], A[5, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[9, 0], A[9, 1], A[9, 2]);
 glEnd;

 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[4, 0], A[4, 1], A[4, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[5, 0], A[5, 1], A[5, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[10, 0], A[10, 1], A[10, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[5, 0], A[5, 1], A[5, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[6, 0], A[6, 1], A[6, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[10, 0], A[10, 1], A[10, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[6, 0], A[6, 1], A[6, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[7, 0], A[7, 1], A[7, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[10, 0], A[10, 1], A[10, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[4, 0], A[4, 1], A[4, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[7, 0], A[7, 1], A[7, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[10, 0], A[10, 1], A[10, 2]);
 glEnd;

 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[6, 0], A[6, 1], A[6, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[7, 0], A[7, 1], A[7, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[11, 0], A[11, 1], A[11, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[2, 0], A[2, 1], A[2, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[7, 0], A[7, 1], A[7, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[11, 0], A[11, 1], A[11, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[1, 0], A[1, 1], A[1, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[2, 0], A[2, 1], A[2, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[11, 0], A[11, 1], A[11, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[1, 0], A[1, 1], A[1, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[6, 0], A[6, 1], A[6, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[11, 0], A[11, 1], A[11, 2]);
 glEnd;

 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[2, 0], A[2, 1], A[2, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[3, 0], A[3, 1], A[3, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[12, 0], A[12, 1], A[12, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[3, 0], A[3, 1], A[3, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[4, 0], A[4, 1], A[4, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[12, 0], A[12, 1], A[12, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[4, 0], A[4, 1], A[4, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[7, 0], A[7, 1], A[7, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[12, 0], A[12, 1], A[12, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[2, 0], A[2, 1], A[2, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[7, 0], A[7, 1], A[7, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[12, 0], A[12, 1], A[12, 2]);
 glEnd;

 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[0, 0], A[0, 1], A[0, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[1, 0], A[1, 1], A[1, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[13, 0], A[13, 1], A[13, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[1, 0], A[1, 1], A[1, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[6, 0], A[6, 1], A[6, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[13, 0], A[13, 1], A[13, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[5, 0], A[5, 1], A[5, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[6, 0], A[6, 1], A[6, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[13, 0], A[13, 1], A[13, 2]);
 glEnd;
 glBegin(GL_TRIANGLES);
   glTexCoord2d(-1,-1);
   glVertex3f(A[0, 0], A[0, 1], A[0, 2]);
   glTexCoord2d(1,-1);
   glVertex3f(A[5, 0], A[5, 1], A[5, 2]);
   glTexCoord2d(1,1);
   glVertex3f(A[13, 0], A[13, 1], A[13, 2]);
 glEnd;
end;

procedure Reset;
var
  i : 0..POINT_COUNT - 1;
begin
  For i := 0 to POINT_COUNT - 1 do begin
    points[i][0] := 0.0;
    points[i][1] := 0.0;
    points[i][2] := 0.0;
    motion[i][0] := (Random - 0.5) / 20;
    motion[i][1] := Random / 7 + 0.01;
    motion[i][2] := (Random - 0.5) / 20;
  end;
end;

procedure UpdatePOINT(i: Word);
begin
  points[i][0] := points[i][0] + motion[i][0];
  points[i][1] := points[i][1] + motion[i][1];
  points[i][2] := points[i][2] + motion[i][2];

  If points[i][1] < 0.0 then begin
    points[i][0] := 0.0;
    points[i][1] := 0.0;
    points[i][2] := 0.0;
    motion[i][0] := (Random - 0.5) / 20;
    motion[i][1] := Random / 7 + 0.01;
    motion[i][2] := (Random - 0.5) / 20;
    end
    else motion[i][1] := motion[i][1] - 0.01;
end;

procedure TForm1.PrepareImage(bmap: string);
type
  PPixelArray = ^TPixelArray;
  TPixelArray = array [0..0] of Byte;
var
  Bitmap : TBitmap;
  Data : PPixelArray;
  BMInfo : TBitmapInfo;
  I, ImageSize : Integer;
  Temp : Byte;
  MemDC : HDC;
begin
  Bitmap := TBitmap.Create;
  Bitmap.LoadFromFile(bmap);
  with BMinfo.bmiHeader do begin
    FillChar (BMInfo, SizeOf(BMInfo), 0);
    biSize := sizeof (TBitmapInfoHeader);
    biBitCount := 24;
    biWidth := Bitmap.Width;
    biHeight := Bitmap.Height;
    ImageSize := biWidth * biHeight;
    biPlanes := 1;
    biCompression := BI_RGB;
    MemDC := CreateCompatibleDC (0);
    GetMem (Data, ImageSize * 3);
    try
      GetDIBits (MemDC, Bitmap.Handle, 0, biHeight, Data,
                 BMInfo, DIB_RGB_COLORS);
      For I := 0 to ImageSize - 1 do begin
          Temp := Data [I * 3];
          Data [I * 3] := Data [I * 3 + 2];
          Data [I * 3 + 2] := Temp;
      end;
      glTexImage2d(GL_TEXTURE_2D, 0, 3, biWidth,
                   biHeight, 0, GL_RGB, GL_UNSIGNED_BYTE, Data);
    finally
      FreeMem (Data);
      DeleteDC (MemDC);
      Bitmap.Free;
    end;
  end;
end;

procedure TForm1.Init;
var
 Quadric : GLUquadricObj;
 NeboOj : GLUquadricObj;
 sc: GLFloat; //  
 HHeight, HWidth: GLFloat;
 i, KamFont: Integer;
begin

  glEnable(GL_DOUBLEBUFFER);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_COLOR_MATERIAL);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  gluPerspective({Perspective,}
                 20,
                 Panel1.Width / Panel1.Height,
                 0.01,
                 100.0);

  gluLookAt(eyex, eyey, eyez,
            centerx, eyey+centery, centerz,
            upx, upy, upz);

    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, @mat_ambient);
    glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, @mat_diffuse);
    glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, @high_shininess);

{  glEnable(GL_FOG);
  glFogi (GL_FOG_MODE, GL_LINEAR);
  glHint (GL_FOG_HINT, GL_NICEST);  //  per pixel
  glFogf (GL_FOG_START, 0);
  glFogf (GL_FOG_END, 10);
  glFogfv (GL_FOG_COLOR, @fogColor);
//  glClearColor(0.0, 0.0, 0.0, 1.0);
}
//  glDepthFunc(GL_LESS);
//  glShadeModel(GL_FLAT);

  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_POSITION, @position2);
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, @lmodel_ambient);
  glLightfv(GL_LIGHT0, GL_AMBIENT, @Ambient1);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, @Diffuse1);
  glLightfv(GL_LIGHT0, GL_SPECULAR, @Specular1);
//  glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, 0);
  glEnable(GL_LIGHT1);
  glLightfv(GL_LIGHT1, GL_POSITION, @position1);
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, @lmodel_ambient);
  glLightfv(GL_LIGHT1, GL_AMBIENT, @Ambient2);
  glLightfv(GL_LIGHT1, GL_DIFFUSE, @Diffuse1);
  glLightfv(GL_LIGHT1, GL_SPECULAR, @Specular1);

 Quadric := gluNewQuadric;
 NeboOj := gluNewQuadric;
 gluQuadricTexture (Quadric, TRUE);
 gluQuadricTexture (NeboOj, TRUE);

 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR{GL_NEAREST});
 glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR{GL_NEAREST});

 glEnable(GL_POINT_SMOOTH);
 glEnable(GL_LINE_SMOOTH);
 glEnable(GL_POLYGON_SMOOTH);

 // 
 glNewList (Nebo, GL_COMPILE);
   PrepareImage('earth.bmp');
   glDisable(GL_LIGHTING);
   gluSphere(NeboOj, RadiusMax, 32, 16);
   glEnable(GL_LIGHTING);
 glEndList;

//  glNormal3f(0, 0, -1);

 // 
 glNewList(Ploshad, GL_COMPILE);
   PrepareImage('Trava.bmp');
   glColor3f(0.0, 1.0, 0.0);
   glBegin(GL_QUADS);
     glNormal3f(0, 1, 0);
     glTexCoord2d(-5,-5);
     glVertex3f(-50, 0, -50);
     glTexCoord2d(5,-5);
     glVertex3f(50, 0, -50);
     glTexCoord2d(5,5);
     glVertex3f(50, 0, 50);
     glTexCoord2d(-5,5);
     glVertex3f(-50, 0, 50);
   glEnd;
 glEndList;

  // 
  sc := 1.0;
 glNewList (Zabor, GL_COMPILE);
   glNormal3f(1, 1, 1);
   PrepareImage ('kirpich.bmp');
   HHeight := 0.5;
   glColor3f(1.0, 0.0, 0.5);
   glBegin(GL_QUADS);
//     glNormal3f(0, 0, 1);
    glTexCoord2d(-sc*60,-sc);
    glVertex3f(-30, 0, -30);
    glTexCoord2d(sc*60,-sc);
    glVertex3f(30, 0, -30);
    glTexCoord2d(sc*60,sc);
    glVertex3f(30, HHeight, -30);
    glTexCoord2d(-sc*60,sc);
    glVertex3f(-30, HHeight, -30);
  glEnd;
  glBegin(GL_QUADS);
//     glNormal3f(1, 0, 0);
    glTexCoord2d(-sc*60,-sc);
    glVertex3f(30, 0, -30);
    glTexCoord2d(sc*60,-sc);
    glVertex3f(30, 0, 30);
    glTexCoord2d(sc*60,sc);
    glVertex3f(30, HHeight, 30);
    glTexCoord2d(-sc*60,sc);
    glVertex3f(30, HHeight, -30);
  glEnd;
  glBegin(GL_QUADS);
//     glNormal3f(0, 0, -1);
    glTexCoord2d(-sc*60,-sc);
    glVertex3f(30, 0, 30);
    glTexCoord2d(sc*60,-sc);
    glVertex3f(-30, 0, 30);
    glTexCoord2d(sc*60,sc);
    glVertex3f(-30, HHeight, 30);
    glTexCoord2d(-sc*60,sc);
    glVertex3f(30, HHeight, 30);
  glEnd;
  glBegin(GL_QUADS);
//     glNormal3f(-1, 0, 0);
    glTexCoord2d(-sc*60,-sc);
    glVertex3f(-30, 0, 30);
    glTexCoord2d(sc*60,-sc);
    glVertex3f(-30, 0, -30);
    glTexCoord2d(sc*60,sc);
    glVertex3f(-30, HHeight, -30);
    glTexCoord2d(-sc*60,sc);
    glVertex3f(-30, HHeight, 30);
  glEnd;
 glEndList;

 // 
 glNewList (Stena, GL_COMPILE);
   PrepareImage('Stena.bmp');
   HHeight := 2;
   glColor3f (0.99, 0.99, 0.99);
   sc := 10;
  glBegin(GL_QUADS);
     glNormal3f(0, 0, -1);
    glTexCoord2d(-sc,-sc);
    glVertex3f(-3, 0, -3);
    glTexCoord2d(sc,-sc);
    glVertex3f(3, 0, -3);
    glTexCoord2d(sc,sc);
    glVertex3f(3, HHeight, -3);
    glTexCoord2d(-sc,sc);
    glVertex3f(-3, HHeight, -3);
  glEnd;
  glBegin(GL_QUADS);
     glNormal3f(1, 0, 0);
    glTexCoord2d(-sc,-sc);
    glVertex3f(3, 0, -3);
    glTexCoord2d(sc,-sc);
    glVertex3f(3, 0, 3);
    glTexCoord2d(sc,sc);
    glVertex3f(3, HHeight, 3);
    glTexCoord2d(-sc,sc);
    glVertex3f(3, HHeight, -3);
  glEnd;
  glBegin(GL_QUADS);
     glNormal3f(0, 0, 1);
    glTexCoord2d(-sc,-sc);
    glVertex3f(3, 0, 3);
    glTexCoord2d(sc,-sc);
    glVertex3f(-3, 0, 3);
    glTexCoord2d(sc,sc);
    glVertex3f(-3, HHeight, 3);
    glTexCoord2d(-sc,sc);
    glVertex3f(3, HHeight, 3);
  glEnd;
  glBegin(GL_QUADS);
     glNormal3f(-1, 0, 0);
    glTexCoord2d(-sc,-sc);
    glVertex3f(-3, 0, 3);
    glTexCoord2d(sc,-sc);
    glVertex3f(-3, 0, -3);
    glTexCoord2d(sc,sc);
    glVertex3f(-3, HHeight, -3);
    glTexCoord2d(-sc,sc);
    glVertex3f(-3, HHeight, 3);
  glEnd;
//   gluSphere(Quadric, 1.0, 6, 3);
 glEndList;

  Randomize;
  // 1
  CreateArray(Kam1, 0.2);   //   30 
  glNewList (Kamen1, GL_COMPILE);
    PrepareImage('Kamen1.bmp');
    glColor3f(0.5, 0.5, 0.5);
    DrawKamen(Kam1);
  glEndList;
  // 2
  CreateArray(Kam2, 0.2);
  glNewList (Kamen2, GL_COMPILE);
    DrawKamen(Kam2);
  glEndList;
  // 3
  CreateArray(Kam3, 0.2);
  glNewList (Kamen3, GL_COMPILE);
    DrawKamen(Kam3);
  glEndList;
  // 4
  CreateArray(Kam4, 0.2);
  glNewList (Kamen4, GL_COMPILE);
    DrawKamen(Kam4);
  glEndList;

  //   
  i := 1;
  KamFont := 10;
  while i <= 62.8*RadiusFontan do
    begin
      CreateArray(KamFontan[i], 0.1);     //   15 
      glNewList (KamFont, GL_COMPILE);
      DrawKamen(KamFontan[i]);
      glEndList;
      KamFont := KamFont + 1;
      i := i + 1;
    end;

  // 
  glNewList (Luga1, GL_COMPILE);
    glColor3f(0.5, 0.5, 1.0);
    PrepareImage('Water.bmp');
    gluDisk(Quadric, 0.0, RadiusFontan, 40, 1);
  glEndList;

 gluDeleteQuadric (Quadric);
 gluDeleteQuadric (NeboOj);

 glEnable(GL_DEPTH_TEST);
end;

procedure SetDCPixelFormat(HDC: HDC);
var
  pfd: TPixelFormatDescriptor;
  nPixelFormat: Integer;
begin
  FillChar(pfd, SizeOf(pfd), 0);
  pfd.dwFlags := PFD_DRAW_TO_WINDOW or
                 PFD_SUPPORT_OPENGL or
                 PFD_DOUBLEBUFFER;
  nPixelFormat := ChoosePixelFormat(HDC, @pfd);
  SetPixelFormat(HDC, nPixelFormat, @pfd);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DC := GetDC(Panel1.Handle);
  SetDCPixelFormat(DC);
  HRC := wglCreateContext(DC);
  wglMakeCurrent(DC, HRC);
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  glClearColor(0.0, 0.0, 0.0, 1.0);
  glDepthFunc(GL_LESS);
  glEnable(GL_DEPTH_TEST);
//  glShadeModel(GL_FLAT);

  Sphere := gluNewQuadric;
  gluQuadricDrawStyle(Sphere, GLU_FILL);

 lastCount := GetTickCount;
 frameCount := 0;
 glPointSize(2);
 Reset;

 eyex := 0;
 eyey := 0.5;
 eyez := 15.0;
 centerx := 0.0;
 centery := 0.0;
 centerz := 16.0;
 upx := 0;
 upy := 1;
 upz := 0;

  Position1[0] := 10;
  Position1[1] := 50;
  Position1[2] := -30;
  Position1[3] := 1.0;

  Position2[0] := 10;
  Position2[1] := 50;
  Position2[2] := -30;
  Position2[3] := 1.0;

  Init;

  ClearBitMap := TBitMap.Create;
  ClearBitMap.Width := Panel3.Width;
  ClearBitMap.Height := Panel3.Height;
  DCPanel3 := GetDC(Panel3.Handle);

  SetTimer(Handle, TimerID, 1, nil);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  Panel2.Left := ClientWidth - Panel2.Width;
  Panel2.Top := 0;
  Panel2.Height := ClientHeight - StatusBar1.Height;
  Panel1.Left := 0;
  Panel1.Height := Panel2.Height;
  Panel1.Width := Panel2.Left - 5;
  Panel1.Top := 0;
  wglMakeCurrent(DC, HRC);
  glViewPort(0, 0, Panel1.Width, Panel1.Height);
  glClearColor(0.0, 0.0, 0.0, 1.0);
 InvalidateRect(Handle, nil, False);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  glDeleteLists (Stena, 4);
  wglMakeCurrent(0, 0);

  wglDeleteContext(HRC);
  ReleaseDC (Handle, DC);
  DeleteDC (DC);
  KillTimer(Handle, TimerID);
  ClearBitMap.Free;
end;

procedure TForm1.WMPaint(var Msg: TWMPaint);
var
  ps: TPaintStruct;
  i, x, y, z: Integer;
  P: TPoint;
  KamFont: Integer;
begin
  BeginPaint(Form1.Handle, ps);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

  glLoadIdentity;
  gluPerspective(50,
                 Panel1.Width / Panel1.Height,
                 1.0,
                 101.0);
  glTranslatef (XPos, YPos, ZPos);

  gluLookAt(eyex, eyey, eyez,
            centerx, eyey+centery, centerz,
            upx, upy, upz);

  glEnable(GL_POINT_SMOOTH);
  glEnable(GL_LINE_SMOOTH);
  glEnable(GL_POLYGON_SMOOTH);

  glTranslatef (EyeX+XPos, 0.0, EyeZ+ZPos);
  glRotatef(AngleY, 0, 1, 0);
  glRotatef(AngleX, cos(AngleY), sin(AngleY), 0);
  glTranslatef (-EyeX-XPos, 0.0, -EyeZ-ZPos);

  glLightfv(GL_LIGHT0, GL_POSITION, @position2);
  glDisable(GL_LIGHTING);
    // 
      glColor3f (1.0, 0.99, 0.1);
      glPushMatrix;
      glTranslatef(position2[0], position2[1], position2[2]);
      gluSphere(Sphere, 0.2, 4, 2);
      glPopMatrix;
  glEnable(GL_LIGHTING);

  if N3.Checked then glEnable(GL_TEXTURE_2D);

  if N5.Checked then glEnable(GL_LIGHTING)
  else glDisable(GL_LIGHTING);

  // 
  glCallList(Ploshad);

  // 
  if N3.Checked then glColor3f(1.0, 1.0, 1.0)
  else glColor3f(0.24, 0.58, 1.0);
  glPushMatrix;
  Angle := Angle + 0.1;
  glRotatef(Angle, 1, 1, 1);
  glCallList(Nebo);
  glPopMatrix;

  // 
  glCallList(Stena);

  // 
  glCallList(Zabor);

  // 
  if N2.Checked then
    begin
      // 
      glPushMatrix;
      glTranslatef (-0.2, 0.1, 0);
      glCallList(Kamen1);
      glTranslatef (0.2, 0.0, -0.2);
      glCallList(Kamen2);
      glTranslatef (0.2, 0.0, 0.2);
      glCallList(Kamen3);
      glTranslatef (-0.2, 0.0, 0.2);
      glCallList(Kamen4);
      glPopMatrix;

      i := 1;
      KamFont := 10;
      while i <= 62.8*RadiusFontan do
        begin
          glPushMatrix;
          glTranslatef(RadiusFontan*cos(3.14/180 * i * 360/62.8/RadiusFontan),
                       0.05,
                       RadiusFontan*sin(3.14/180 * i * 360/62.8/RadiusFontan));
          glCallList(KamFont);
          glPopMatrix;
          KamFont := KamFont + 1;
          i := i + 1;
        end;

      //  
      glPushMatrix;
      glRotate(90, 1, 0, 0);
      glTranslatef (0, 0, -0.01);
      glCallList(Luga1);
      glPopMatrix;
      glDisable(GL_TEXTURE_2D);
      glColor4f(0, 0.5, 1, 0.5);
      glBegin(GL_POINTS);
        for i := 0 to POINT_COUNT - 1 do
          begin
            UpdatePOINT(i);
            glVertex3fv(@points[i]);
          end;
      glEnd;
    end;

  if N3.Checked then glDisable(GL_TEXTURE_2D);

  SwapBuffers(DC);
  EndPaint(Form1.Handle, ps);

  //   
  if N4.Checked then
    begin
      x := Round((50-EyeX-XPos)*Panel3.Width/100);
      y := Round((50-EyeZ-ZPos)*Panel3.Height/100);
      BitBlt(DCPanel3, 0, 0, Panel3.Width, Panel3.Height, ClearBitMap.Canvas.Handle, 0, 0, SRCCOPY);
      Windows.Ellipse(DCPanel3, x-1, y-1, x+1, y+1);
      Windows.Ellipse(DCPanel3,
                 x + Round(20*cos((AngleY-90)*3.14/180))-2,
                 y + Round(20*sin((AngleY-90)*3.14/180))-2,
                 x + Round(20*cos((AngleY-90)*3.14/180))+2,
                 y + Round(20*sin((AngleY-90)*3.14/180))+2);
    end;

 newCount := GetTickCount;
 Inc(frameCount);
 if (newCount - lastCount) > 1000 then
   begin //  
     fpsRate := frameCount * 1000 / (newCount - lastCount);
     Caption := 'FPS - ' + FloatToStr (fpsRate);
     lastCount := newCount;
     frameCount := 0;
   end;
end;

procedure TForm1.WMTimer(var Msg: TWMTimer);
begin
  InvalidateRect(Handle, nil, false);
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ch: Integer; //     
begin
  if Key = VK_ESCAPE then Close;
  if Abs(AngleY) > 360 then AngleY := (AngleY mod 360) * 360;  
  if (AngleY >= -45) and (AngleY < 45) then ch := 1;
  if (AngleY >= -135) and (AngleY < -45) then ch := 2;
  if (AngleY >= -225) and (AngleY < -135) then ch := 3;
  if (AngleY >= -315) and (AngleY < -225) then ch := 4;
  if (AngleY >= -405) and (AngleY < -315) then ch := 1;
  if (AngleY >= -495) and (AngleY < -405) then ch := 2;
  if (AngleY >= -585) and (AngleY < -495) then ch := 3;
  if (AngleY >= -675) and (AngleY < -585) then ch := 4;
  if (AngleY < 135) and (AngleY >= 45) then ch := 4;
  if (AngleY < 225) and (AngleY >= 135) then ch := 3;
  if (AngleY < 315) and (AngleY >= 225) then ch := 2;
  if (AngleY < 405) and (AngleY >= 315) then ch := 1;
  if (AngleY < 495) and (AngleY >= 405) then ch := 4;
  if (AngleY < 585) and (AngleY >= 495) then ch := 3;
  if (AngleY < 675) and (AngleY >= 585) then ch := 2;

  case Key of
    65:
      begin
//        XPos := XPos + 0.25;
//        ZPos := ZPos + 0.25 * tan(AngleY*3.14/180);
        case ch of
          1:
            begin
              XPos := XPos + 0.25;
              ZPos := ZPos + 0.25 * tan(AngleY*3.14/180);
            end;
          2:
            begin
              ZPos := ZPos - 0.25;
              XPos := XPos + 0.25 * tan((AngleY+90)*3.14/180);
            end;
          3:
            begin
              XPos := XPos - 0.25;
              ZPos := ZPos - 0.25 * tan((AngleY+180)*3.14/180);
            end;
          4:
            begin
              ZPos := ZPos + 0.25;
              XPos := XPos - 0.25 * tan((AngleY+270)*3.14/180);
            end;
        end;
      end;
    68:
      begin
//        XPos := XPos - 0.25;
        case ch of
          1:
            begin
              XPos := XPos - 0.25;
              ZPos := ZPos - 0.25 * tan(AngleY*3.14/180);
            end;
          2:
            begin
              ZPos := ZPos + 0.25;
              XPos := XPos - 0.25 * tan((AngleY+90)*3.14/180);
            end;
          3:
            begin
              XPos := XPos + 0.25;
              ZPos := ZPos + 0.25 * tan((AngleY+180)*3.14/180);
            end;
          4:
            begin
              ZPos := ZPos - 0.25;
              XPos := XPos + 0.25 * tan((AngleY+270)*3.14/180);
            end;
        end;
      end;
    88:
      begin
//        ZPos := ZPos - 0.25;
//        XPos := XPos + 0.25 * tan(AngleY*3.14/180);
        case ch of
          1:
            begin
              ZPos := ZPos - 0.25;
              XPos := XPos + 0.25 * tan(AngleY*3.14/180);
            end;
          2:
            begin
              XPos := XPos - 0.25;
              ZPos := ZPos - 0.25 * tan((AngleY+90)*3.14/180);
            end;
          3:
            begin
              ZPos := ZPos + 0.25;
              XPos := XPos - 0.25 * tan((AngleY+180)*3.14/180);
            end;
          4:
            begin
              XPos := XPos + 0.25;
              ZPos := ZPos + 0.25 * tan((AngleY+270)*3.14/180);
            end;
        end;
      end;
    83: // 
      begin
        case ch of
          1:
            begin
              ZPos := ZPos + 0.25;
              XPos := XPos - 0.25 * tan(AngleY*3.14/180);
            end;
          2:
            begin
              XPos := XPos + 0.25;
              ZPos := ZPos + 0.25 * tan((AngleY+90)*3.14/180);
            end;
          3:
            begin
              ZPos := ZPos - 0.25;
              XPos := XPos + 0.25 * tan((AngleY+180)*3.14/180);
            end;
          4:
            begin
              XPos := XPos - 0.25;
              ZPos := ZPos - 0.25 * tan((AngleY+270)*3.14/180);
            end;
        end;
      end;
    38: YPos := YPos - 0.25;
    40: YPos := YPos + 0.25;
    49: AngleY := AngleY - 5;
    50: AngleY := AngleY + 5;
    51: AngleX := AngleX - 5;
    52: AngleX := AngleX + 5;
  end;

  case Key of
    98: Position2[1] := Position2[1] - 0.2;
    104: Position2[1] := Position2[1] + 0.2;
    100: Position2[0] := Position2[0] + 0.2;
    102: Position2[0] := Position2[0] - 0.2;
    101:
      if Shift = [ssShift] then Position2[1] := Position2[1] + 0.2
      else Position2[2] := Position2[2] - 0.2
  end;
  Position2[0] := XPos;
  Position2[1] := YPos;
  Position2[2] := ZPos + EyeZ;
  StatusBar1.SimpleText := FloatToStr(Position2[0]) + ' ' + FloatToStr(Position2[1]) + ' ' + FloatToStr(Position2[2]);

  //     ""
{  if XPos*XPos + ZPos*ZPos > RadiusMax*RadiusMax then
    begin
      if XPos > ZPos then XPos := sqrt(RadiusMax*RadiusMax - ZPos*ZPos)
      else ZPos := sqrt(RadiusMax*RadiusMax - XPos*XPos);
    end;}

//  StatusBar1.SimpleText := 'AngleY = ' + FloatToStr(Round(AngleY*100)/100);
  FormResize(nil);
end;

procedure TForm1.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Shift = [ssLeft] then
    begin
      AngleY := AngleYAld + (X - XDown) * 2;
//      if AngleY > 360 then AngleY := AngleY - 360;
//      if AngleY < -360 then AngleY := AngleY + 360;
//      AngleX := (Y - Panel1.Height div 2);
    end;
end;

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  XDown := X;
  YDown := Y;
  AngleYAld := AngleY;
end;

procedure TForm1.N2Click(Sender: TObject);
begin
  N2.Checked := not N2.Checked;
  Reset; 
end;

procedure TForm1.N3Click(Sender: TObject);
begin
  N3.Checked := not N3.Checked;
end;

procedure TForm1.N4Click(Sender: TObject);
begin
  N4.Checked := not N4.Checked;
end;

procedure TForm1.N5Click(Sender: TObject);
begin
  N5.Checked := not N5.Checked;
end;

end.
